from java.lang import Math
from visad import Data
import hydra_globals
from hydra_globals import geoPointRef_s


#-- input:
#     lon: -180 to 180,  lat: -90 to 90
#-- output:
#     km (kilometers)
def distOnEarth(lon1, lat1, lon2, lat2):
  lon1 = lon1*Data.DEGREES_TO_RADIANS
  lon2 = lon2*Data.DEGREES_TO_RADIANS
  lat1 = lat1*Data.DEGREES_TO_RADIANS
  lat2 = lat2*Data.DEGREES_TO_RADIANS
  del_lat = lat2 - lat1
  del_lon = lon2 - lon1
  ds = 2*6380*Math.asin(Math.sqrt(Math.sin(del_lat/2)*Math.sin(del_lat/2)+Math.cos(lat1)*Math.cos(lat2)*Math.sin(del_lon/2)*Math.sin(del_lon/2)))
  return ds

 
def radToBT(val):
  from hydra_globals import mcViewer_s, mcViewer_cnt
  return mcViewer_s[mcViewer_cnt-1].radToBT(val)

def BTtoRad(val):
  from hydra_globals import mcViewer_s, mcViewer_cnt
  return mcViewer_s[mcViewer_cnt-1].BTtoRad(val)
