from visad import DisplayListener, Tuple, Real, Text, TupleType

class roamProbe(DisplayListener):
  def __init__(self, display, ad, toolbar, textRef, y, x, txt, valueGet, ds_cs=None):
    self.display = display
    self.display.addDisplayListener(self)
    self.dr = display.getDisplayRenderer()
    self.ad = ad
    self.toolbar = toolbar
    self.textRef = textRef
    self.x = x
    self.y = y
    self.txt = txt
    self.last_lon = None
    self.last_lat = None
    self.last_val = None
    self.valueGet = valueGet
    self.ds_cs = ds_cs

  def displayChanged(self, event):
    if event.getId() == 2 or event.getId() == 3:
      return
    lat = self.dr.getDirectAxisValue("Latitude")
    lon = self.dr.getDirectAxisValue("Longitude")

    if self.toolbar == None:
      val = self.valueGet(lat,lon)
      if val != self.last_val:
        self.textRef.setData(Tuple(TupleType([self.y, self.x, self.txt]), [Real(self.y, lat), Real(self.x, lon), Text(self.txt, '   %-6.2f' % val)]))
        last_val = val
      return

    if self.toolbar.pickAction.enabled == 1:
      val = self.valueGet(lat,lon).getValue()
      if val != self.last_val:
        self.textRef.setData(Tuple(TupleType([self.y, self.x, self.txt]), [Real(self.y, lat), Real(self.x, lon), Text(self.txt, '   %-6.2f' % val)])) 
        last_val = val

  def __del__(self):
    self.display.removeDisplayListener(self)


  def update(self, lonlatTuple, enabled=0):
    if lonlatTuple != None:
      comps = lonlatTuple.getComponents()
      x = comps[0].getValue()
      y = comps[1].getValue()
      if self.ds_cs != None:
        ll = self.ds_cs.toReference([[x],[y],[0]])

    lon = x
    lat = y

    if self.toolbar == None:
      val = self.valueGet(lat,lon)
      if val != self.last_val:
        self.textRef.setData(Tuple(TupleType([self.y, self.x, self.txt]), [Real(self.y, lat), Real(self.x, lon), Text(self.txt, '   %-6.2f' % val)]))
        last_val = val
      return

    if self.toolbar.pickAction.enabled == 1 or enabled == 1:
      val = self.valueGet(lat,lon).getValue()
      if val != self.last_val:
        self.textRef.setData(Tuple(TupleType([self.y, self.x, self.txt]), [Real(self.y, lat), Real(self.x, lon), Text(self.txt, '   %-6.2f' % val)]))
        last_val = val
