import jarray
import java
from javax.swing import *
from javax.swing.border import LineBorder, CompoundBorder, EmptyBorder
from java.awt import GridLayout, BorderLayout, FlowLayout, Color, Dimension, Canvas
from java.awt.event import InputEvent, ActionEvent
import subs, graph
from subs import *
from graph import *
from visad.python.JPythonMethods import *
from visad import *
from visad.java3d import DirectManipulationRendererJ3D
from visad.bom import PickManipulationRendererJ3D, RubberBandBoxRendererJ3D, CurveManipulationRendererJ3D, HydraImageRendererJ3D
from visad.util import Delay
from ui.colorbar import ColorBarWidget, ColorBar
from java.util import StringTokenizer
from java.lang import Float, Thread, Integer, Math, Runtime
from util import Helper, ValueHistogram, OneDProbeRendererJ3D, MyRubberBandBoxRendererJ3D
from histostretch import linkHistLocation, dragHistLocation, dragHistLocationColorFunction
from DisplayViewSelect import DisplayViewSelectToolBar, HAction
import hydra_properties

#---------------------------------------
false = 0
true  = 1
lightWeightPopupEnabled = false
#---------------------------------------
selector_colors = [Color.magenta, Color(0.5, 0.5, 0.0), Color(0.0, 0.5, 0.5), Color(1.0, 0.0, 0.0), Color(0.0, 0.0, 1.0)]

runtime = Runtime.getRuntime()

import hydra_properties
import hydra_globals
from hydra_globals import getImageRenderer
from hframe import HFrame

class SpectrumDisplay:
  def __init__(self, filereader, callback=None):
    self.filereader = filereader
    self.spectrum = filereader.getObservations(0,0)
    self.obs_valid_range = self.filereader.getObsValidRange()

    #-- VisAD displays are awt.Canvas -> Canvas3D, so mixing heavyweight/lightweight
    #-- components causes problems with the popup menus always rendered beneath the Canvas
    JPopupMenu.setDefaultLightWeightPopupEnabled(lightWeightPopupEnabled)
                                                                                                                                       
    frame     = HFrame("spectrum", windowClosing=self.windowClose)
    framePane = frame.getContentPane()
    framePane.setLayout(BorderLayout())
                                                                                                                                       
    global spectrumDisplay
                                                                                                                                       
    obsElementInstrument, obsLineInstrument, obsChannelIndexInstrument, observationChannelsInstrument, observationsInstrument = self.filereader.getRealTypes()
    rtype = self.filereader.spectrumRangeType
                                                                                                                                       
    dset    = self.filereader.observationDomain
    self.lo = dset.getLow()
    self.hi = dset.getHi()
    lens    = dset.getLengths()
    spmps = None
    ylohi = None
                                                                                                                                       
    if isinstance(rtype, RealTupleType):
      spmps = makeMaps(observationChannelsInstrument,'x',rtype.getComponent(0),'y',rtype.getComponent(1),'y')
      spmps[0].setRange(self.lo[0], self.hi[0])
      spmps[1].setRange(self.obs_valid_range[0][0], self.obs_valid_range[0][1])
      spmps[2].setRange(self.obs_valid_range[1][0], self.obs_valid_range[1][1])
      as = spmps[2].getAxisScale()
      as.setVisible(1)
      as.setSide(1)
      as.setColor(Color.magenta)
      ylohi = self.obs_valid_range[1]
      observationsInstrument = rtype.getComponent(1)
      self.ymap2 = spmps[2]
    else:
      spmps = makeMaps(observationChannelsInstrument,'x',observationsInstrument,'y')
      spmps[1].setRange(self.obs_valid_range[0], self.obs_valid_range[1])
      spmps[0].setRange(self.lo[0], self.hi[0])
      ylohi = self.obs_valid_range
                                                                                                                                       
    spectrumDisplay = makeDisplay(spmps)
    subs.setAspectRatio(spectrumDisplay,2)
    mode = spectrumDisplay.getGraphicsModeControl()
    mode.setPointSize(5)
    showAxesScales(spectrumDisplay,1)
    setBoxSize(spectrumDisplay,.6,clip=0)

    dsp_rdr = spectrumDisplay.getDisplayRenderer()
    dsp_rdr.setBackgroundColor(hydra_properties.background_color)
    dsp_rdr.setForegroundColor(hydra_properties.foreground_color)
                                                                                                                                       
    if isinstance(rtype, RealTupleType):
      addData('b',self.spectrum.getComponent(0),spectrumDisplay,subs.makeColorMap(hydra_properties.foreground_color),zlayer=-0.05)
      addData('b',self.spectrum.getComponent(1),spectrumDisplay,subs.makeColorMap("magenta"),zlayer=-0.05)
    else:
      addData('b',self.spectrum,spectrumDisplay,subs.makeColorMap(hydra_properties.foreground_color), zlayer=-0.05)
    #---------------------------
                                                                                                                                       
    self.pcntrl = spectrumDisplay.getProjectionControl()
    self.imtrx  = self.pcntrl.getMatrix()
    self.xmap   = spmps[0]
    self.ymap   = spmps[1]
                                                                                                                                       


#-- from acViewer
    """
    textPanelD2 = JPanel()
    textPanelD2.setLayout(FlowLayout())
    xVariable=ad.getObservationChannels()

    channelText = None
    if self.filereader.broadBand == true:
      textPanelD2.add(JLabel("Band: "))
      self.bandNumberText = JComboBox(self.filereader.band_numbers)
      self.bandNumberText.setSelectedItem(self.filereader.band_numbers[self.filereader.fileIndexes[self.channel]])

      class c1(java.awt.event.ActionListener):
        def __init__(self, mom, comboBox):
          self.mom = mom
          self.comboBox = comboBox
        def actionPerformed(self,event):
          self.mom.changeImage(self.mom.filereader.bandNameToValue(self.comboBox.getSelectedItem()), None)

      self.bandNumberText.addActionListener(c1(self, self.bandNumberText))
      textPanelD2.add(self.bandNumberText)
      channelText = self.bandNumberText.getSelectedItem()

    strg=self.filereader.observationDomain.getType().getDomain().toString()
    textPanelD2.add(JLabel(strg))
    strg = '%8.2f' % (xVariable[self.channel])
    if channelText == None:
      channelText = strg
    self.instrumentString1 = JTextField(strg, actionPerformed=self.channelBoxChange)
    textPanelD2.add(self.instrumentString1)
    unit = self.filereader.observationDomain.getType().getDomain().getComponent(0).getDefaultUnit()
    if unit != None:
      textPanelD2.add(JLabel(unit.toString()))
    """
                                                                                                                                       
    global lval, leftSelectRef, rval, rghtSelectRef
                                                                                                                                       
    if self.filereader.instrumentName == "MODIS":
      lval = self.filereader.bandNameToValue('20')
      rval = self.filereader.bandNameToValue('31')
      leftInit = [lval]
      rghtInit = [rval]
    else:
      lval     = int(lens[0]*0.33)
      lval     = 500
      leftInit = self.filereader.observationDomain.indexToValue([lval])[0]
      rval     = int(lens[0]*0.66)
      rghtInit = self.filereader.observationDomain.indexToValue([rval])[0]
                                                                                                                                       
    leftSelectRef = spectrumDisplay.addData("left", Real(observationChannelsInstrument, leftInit[0]),
      constantMaps=[ConstantMap(-0.5, Display.YAxis)]+makeColorMap("red"), renderer=OneDProbeRendererJ3D(dset))

    rghtSelectRef = spectrumDisplay.addData("rght", Real(observationChannelsInstrument, rghtInit[0]),
      constantMaps=[ConstantMap(-0.5, Display.YAxis)]+makeColorMap("green"), renderer=OneDProbeRendererJ3D(dset))
                                                                                                                                       
    global lval2, leftSelectRef2, rval2, rghtSelectRef2

    lval2 = -3000
    leftInit2 = self.filereader.observationDomain.indexToValue([lval2])[0]
    leftSelectRef2 = spectrumDisplay.addData("left", Real(observationChannelsInstrument, lval2),
      constantMaps=[ConstantMap(-0.5, Display.YAxis)]+makeColorMap("blue"), renderer=OneDProbeRendererJ3D(dset))
                                                                                                                                       
    rval2 = -3000
    rghtInit2 = self.filereader.observationDomain.indexToValue([rval2])[0]
    rghtSelectRef2 = spectrumDisplay.addData("rght", Real(observationChannelsInstrument, rval2),
      constantMaps=[ConstantMap(-0.5, Display.YAxis)]+makeColorMap("magenta"), renderer=OneDProbeRendererJ3D(dset))
                                                                                                                                       
    tb = DisplayViewSelectToolBar([spectrumDisplay], [1], pickAction="grab")
                                                                                                                                       
    framePane.add(tb, BorderLayout.SOUTH)
    framePane.add(spectrumDisplay.getComponent(), BorderLayout.CENTER)



    class LeftCell(CellImpl):
      def __init__(self, obs_valid_range):
        self.obs_valid_range = obs_valid_range
        self.lineRefL = spectrumDisplay.drawLine([[lval, lval], [self.obs_valid_range[0], self.obs_valid_range[1]]], color="red", width=2)
                                                                                                                                       
      def doAction(self):
        val = leftSelectRef.getData().getValue()
        spectrumDisplay.moveLine(self.lineRefL, [[val, val], [self.obs_valid_range[0], self.obs_valid_range[1]]])
    lcell = LeftCell(ylohi)
    lcell.addReference(leftSelectRef)
                                                                                                                                       
    class RightCell(CellImpl):
      def __init__(self, obs_valid_range):
        self.obs_valid_range = obs_valid_range
        self.lineRefR = spectrumDisplay.drawLine([[rval, rval], [self.obs_valid_range[0], self.obs_valid_range[1]]], color="green", width=2)
                                                                                                                                       
      def doAction(self):
        val = rghtSelectRef.getData().getValue()
        spectrumDisplay.moveLine(self.lineRefR, [[val, val], [self.obs_valid_range[0], self.obs_valid_range[1]]])
    rcell = RightCell(ylohi)
    rcell.addReference(rghtSelectRef)

    class LeftCell2(CellImpl):
      def __init__(self, obs_valid_range):
        self.obs_valid_range = obs_valid_range
        self.lineRefL = spectrumDisplay.drawLine([[lval2, lval2], [self.obs_valid_range[0], self.obs_valid_range[1]]], color="blue", width=2)
                                                                                                                                       
      def doAction(self):
        val = leftSelectRef2.getData().getValue()
        spectrumDisplay.moveLine(self.lineRefL, [[val, val], [self.obs_valid_range[0], self.obs_valid_range[1]]])
    lcell2 = LeftCell2(ylohi)
    lcell2.addReference(leftSelectRef2)
                                                                                                                                       
    class RightCell2(CellImpl):
      def __init__(self, obs_valid_range):
        self.obs_valid_range = obs_valid_range
        self.lineRefR = spectrumDisplay.drawLine([[rval2, rval2], [self.obs_valid_range[0], self.obs_valid_range[1]]], color="magenta", width=2)
                                                                                                                                       
      def doAction(self):
        val = rghtSelectRef2.getData().getValue()
        spectrumDisplay.moveLine(self.lineRefR, [[val, val], [self.obs_valid_range[0], self.obs_valid_range[1]]])
    rcell2 = RightCell2(ylohi)
    rcell2.addReference(rghtSelectRef2)
                                                                                                                                       
                                                                                                                                       
    self.leftSelectRef = leftSelectRef
    frame.pack()
    frame.show()
    frame.validate()
    frame.addVisADDisplay(spectrumDisplay)

  def windowClose(self, event):
    pass
